IMPLEMENTATION MODULE SigTerm;

  (*------------------------------------------------------------------------*)
  (* Module stellt einen einfachen "Signalhandler" zur Verfuegung.          *)
  (* Module provides a simple "signal handler".                             *)
  (*------------------------------------------------------------------------*)
  (* Letzte Bearbeitung:                                                    *)
  (*                                                                        *)
  (* 28.03.97, MRi.: Durchsicht (m2fanal)                                   *)
  (*------------------------------------------------------------------------*)
  (* Implementation : Michael Riedl                                         *)
  (* Licence        : GNU Lesser General Public License (LGPL)              *)
  (*------------------------------------------------------------------------*)

  (* $Id$ *)

FROM Signals IMPORT SIGTERM,signal,SigHandler;
             IMPORT Errors;
             IMPORT StringsLib;

VAR  Terminate : BOOLEAN;
     Init      : BOOLEAN;
     String    : ARRAY [0..255] OF CHAR;  

PROCEDURE Handler(ih : INTEGER);

BEGIN
      Errors.WriteLn; 
      Errors.WriteString('*** '); 
      Errors.WriteString(String); 
      Errors.WriteString(' ***'); 
      Errors.WriteLn;
      IF NOT Init THEN
        Errors.FatalError('Programm abgebrochen !');
      ELSE (* Ueberlasse die Reaktion dem Rufer von TermProg. *)
        Terminate := TRUE;
      END;
END Handler;

PROCEDURE InitTermProg(str  : ARRAY OF CHAR);

BEGIN
      Init := TRUE;
      StringsLib.Copy(String,str);
(* FUSCH !!!
      signal(SIGTERM,Handler);
 *)
END InitTermProg;

PROCEDURE TermProg() : BOOLEAN;

BEGIN
      RETURN Terminate;
END TermProg;

BEGIN
      Init      := FALSE;
      Terminate := FALSE;
      StringsLib.Copy(String,'Programm erhielt Signal 15 (SIGTERM) !');
END SigTerm.
