IMPLEMENTATION MODULE InOut;

  (*------------------------------------------------------------------------*)
  (* Traditionelles InOut-Modul.                                            *)
  (* Traditional InOut-Modul.                                               *)
  (*------------------------------------------------------------------------*)
  (* Letzte Bearbeitung :                                                   *)
  (*                                                                        *)
  (* 05.10.98, MRi.: Erstellen der erste Version.                           *)
  (*------------------------------------------------------------------------*)
  (* Implementation : Michael Riedl                                         *)
  (* Licence        : GNU Lesser General Public License (LGPL)              *)
  (*------------------------------------------------------------------------*)

  (* $Id: InOut.mod,v 1.1 2015/09/13 20:48:42 mriedl Exp mriedl $ *)

IMPORT TIO;


PROCEDURE WriteString(Str : ARRAY OF CHAR);

BEGIN
      TIO.WrStr(Str); 
END WriteString;

PROCEDURE WriteInt(i      : INTEGER;
                   FeldBr : CARDINAL);
BEGIN
      TIO.WrInt(i,FeldBr);
END WriteInt;

PROCEDURE WriteCard(c      : INTEGER;
                    FeldBr : CARDINAL);
BEGIN
      TIO.WrCard(c,FeldBr);
END WriteCard;

PROCEDURE WriteHex(c      : CARDINAL; 
                   FeldBr : CARDINAL);
BEGIN
      TIO.WrHex(c,FeldBr);
END WriteHex;

PROCEDURE WriteLn();

BEGIN
      TIO.WrLn;
END WriteLn;

PROCEDURE ReadCard(VAR c : CARDINAL);

BEGIN
      TIO.RdCard(c);
END ReadCard;

END InOut.
